MODULE seig_app;

(*  Stand : 15. 4. 88                                                       *)
(*  modifiziert 19.1.93 : Nur Ausgabe von Naeherungen fuer Eigenwerte und   *)
(*                        Eigenvektoren                                     *)
(*  modifiziert 20.1.93 : Schleife in Prozudur JACOBI laeft bis N statt nur *)
(*                        bis N-1                                           *)

use i_ari , mv_ari , mvi_ari;
                                                                                
CONST RNULL = 0.0;
      REINS = 1.0;
                                                                                
GLOBAL                                                                          
PROCEDURE SEIG_APP( VAR A0 : RMATRIX; VAR EW : RVECTOR; VAR EV : RMATRIX );
{ A0 : Eingabematrix, EW, EV Ausgabe Eigenwerte und -vektoren (spaltenweise) }
{
PROCEDURE SEIG( VAR A0 : RMATRIX; VAR EW : IVECTOR; VAR ERRCODE : INTEGER );    
                                                                                
VAR  HM,A,EV,EV1,R  : RMATRIX[1..UB(A0),1..UB(A0)];                             
}                                                                               
VAR  HM,A,EV1,R     : RMATRIX[1..UB(A0),1..UB(A0)];                             
     D,HV           : RVECTOR[1..UB(A0)];                                       
     AJ             : IVECTOR[1..UB(A0)];                                       
     DP             : DOTPRECISION;                                             
     NRM,S,                                                                     
     EPS1,EPS2,EPS3 : REAL;                                                     
     I,J,N          : INTEGER;                                                  
                                                                                
PROCEDURE ORTHONORM( VAR Q : RMATRIX );                                         
VAR J,K : INTEGER;                                                              
    R   : RVECTOR[1..N];                                                        
BEGIN                                                                           
   R:= RNULL;                                                                     
   FOR K:= 1 TO N DO                                                            
   BEGIN                                                                        
      { Orthogonalisiere Spalte k : }                                           
      FOR J := 1 TO K-1 DO  R[J]:= -rvector(q[*,j])*rvector(q[*,k]) ;           
      R[K]  := REINS;                                                             
      Q[*,K]:= Q*R;                                                             
      { Normiere Spalte k : }                                                   
      Q[*,K]:= (1/SQRT( rvector(Q[*,K])*rvector(Q[*,K]) )) * RVECTOR(Q[*,K]);   
   END;                                                                         
END;                                                                            
                                                                                
PROCEDURE ORTHONORM( VAR Q,Q1 : RMATRIX );                                      
VAR J,K          : INTEGER;                                                     
    A,B,QK,Q1K,R : RVECTOR[1..N];                                               
    Z,U,V        : REAL;                                                        
    DP           : DOTPRECISION;                                                
BEGIN                                                                           
   R:= RNULL;                                                                     
   FOR K:= 1 TO N DO                                                            
   BEGIN                                                                        
      { Orthogonalisiere Spalte k : }                                           
      FOR J:= 1 TO K-1 DO                                                       
         R[J]:= #*(   RVECTOR( Q[*,J])*RVECTOR( Q[*,K])                         
                    + RVECTOR( Q[*,J])*RVECTOR(Q1[*,K])                         
                    + RVECTOR(Q1[*,J])*RVECTOR( Q[*,K])                         
                    + RVECTOR(Q1[*,J])*RVECTOR(Q1[*,K])  );                     
      R:= -R;                                                                   
      R[K]:= REINS;                                                               
      QK := #*( Q*R + Q1*R );                                                   
      Q1K:= #*( Q*R + Q1*R - QK );                                              
      { Normiere Spalte k : }                                                   
      DP:= #(  QK*QK + QK*Q1K + Q1K*QK + Q1K*Q1K );                             
      Z:= #*( DP );                                                             
      U:= SQRT(Z);                                                              
      Z:= #*( DP - Z );                                                         
      V:= #*( DP - U*U );                                                       
      V:= V/(2*U);        { U + V  =  SQRT(DP)   }                              
      Z:= 1/(U+V);                                                              
      A:= Z*( QK + Q1K );                                                       
      B:= #*( QK + Q1K - U*A - V*A );                                           
      Q1[*,K]:= Z*B;                                                            
      Q [*,K]:=  A;                                                             
   END;                                                                         
END;                                                                            
                                                                                
FUNCTION TRANSFORM( VAR D: RVECTOR; VAR A,T: RMATRIX )                          
                   : RMATRIX[1..N,1..N];                                        
VAR J  : INTEGER;                                                               
    B  : RMATRIX[1..N,1..N];                                                    
BEGIN                                                                           
   B:= RNULL;                                                                     
   FOR J:= 1 TO N DO  B[J,J]:= D[J];                                            
   B:= #*( A*T - T*B );                                                         
   TRANSFORM:= TRANSP(T)*B;                                                     
END;                                                                            
                                                                                
FUNCTION TRANSFORM( VAR D: RVECTOR; VAR A,T,T1: RMATRIX )                       
                   : RMATRIX[1..N,1..N];                                        
VAR J : INTEGER;                                                                
    B : RMATRIX[1..N,1..N];                                                     
BEGIN                                                                           
   B:= RNULL;                                                                     
   FOR J:= 1 TO N DO  B[J,J]:= D[J];                                            
   B:= #*( A*T + A*T1 - T*B - T1*B );                                           
   TRANSFORM:= #*( TRANSP(T)*B + TRANSP(T1)*B );                                
END;                                                                            
                                                                                
FUNCTION TRANSFORM( VAR D : RVECTOR; VAR A,T,T1 : RMATRIX;                      
                        J : INTEGER; EPS : INTERVAL ) : IVECTOR[1..N];          
VAR I,K    : INTEGER;                                                           
    B,C    : IVECTOR[1..N];                                                     
    H,H1   : RVECTOR[1..N];                                                     
BEGIN                                                                           
   H := RVECTOR(T [*,J]);                                                       
   H1:= RVECTOR(T1[*,J]);                                                       
   C := ##( A*H + A*H1 - D[J]*H - D[J]*H1 );                                    
   FOR I:= 1 TO N DO                                                            
   BEGIN                                                                        
      FOR K:=1 TO N DO B[K]:= T[K,I] + ( T1[K,I] + EPS );                       
      TRANSFORM[I]:= B*C;                                                       
   END;                                                                         
END;                                                                            
                                                                                
FUNCTION NORM( VAR Q,Q1 : RMATRIX ) : REAL;                                     
VAR I,J       : INTEGER;                                                        
    MAX,Y,S   : REAL;                                                           
    D         : INTERVAL;                                                       
    G,G1,H,H1 : RVECTOR [1..N];                                                 
BEGIN                                                                           
   MAX:= RNULL;                                                                   
   FOR I:= 1 TO N DO                                                            
   BEGIN                                                                        
      S:= RNULL;                                                                  
      G := RVECTOR(Q [*,I]);                                                    
      G1:= RVECTOR(Q1[*,I]);                                                    
      FOR J:= 1 TO N DO                                                         
      BEGIN                                                                     
         Y := ORD( I=J );                                                       
         H := RVECTOR(Q [*,J]);                                                 
         H1:= RVECTOR(Q1[*,J]);                                                 
         D := ##( Y - G*H - G*H1 - G1*H - G1*H1 );                              
         S := S + SUP(ABS(D));                                                  
      END;                                                                      
      IF S>MAX THEN MAX:= S;                                                    
   END;                                                                         
   NORM:= MAX;                                                                  
END;                                                                            
                                                                                
PROCEDURE JACOBI( VAR D : RVECTOR; VAR A,W : RMATRIX;                           
                  TIEFE : INTEGER; EPS : REAL ) ;                               
VAR I,J,K    : INTEGER;                                                         
    AJ,AK,AH : RVECTOR[1..N];                                                   
    DP       : DOTPRECISION;                                                    
    ENDE     : BOOLEAN;                                                         
    C,S,T,TH,TAU,                                                               
    MAX,MIND : REAL;                                                            
BEGIN                                                                           
   I:= 0;                                                                       
   REPEAT                                                                       
      I:= I+1;                                                                  
(*----ALT UND FALSCH:  FOR J:=  1  TO N-1 DO ----*)
      FOR J:= 1 TO N DO
      BEGIN                                                                     
         DP    := #( D[J] + A[J,J] );                                           
         D[J]  := #*( DP );                                                     
         A[J,J]:= #*( DP - D[J] );                                              
         FOR K:= J+1 TO  N  DO                                                  
         IF A[J,K]<>RNULL THEN                                                    
         BEGIN                                                                  
            TH:= #*( D[J] + A[J,J] - D[K] - A[K,K] );                           
            T := 2*A[J,K];                                                      
            IF TH=RNULL THEN T:= 1                                                
                      ELSE T:= T / ( ABS(TH) + SQRT(SQR(T)+SQR(TH)) );          
            IF TH<RNULL THEN T:= -T;                                              
            C    := 1/SQRT(1+SQR(T));                                           
            S    := T*C;                                                        
            TAU  := S/(1+C);                                                    
                                                                                
            AJ:= RVECTOR(A[*,J]);                                               
            AK:= RVECTOR(A[*,K]);                                               
            AH:= AJ + S*( AK-TAU*AJ );                                          
            AK:= AK - S*( AJ+TAU*AK );                                          
            AJ:= AH;                                                            
                                                                                
            DP   := #( D[J] + A[J,J] + T*A[J,K] );                              
            D[J] := #*( DP );                                                   
            AJ[J]:= #*( DP - D[J] );                                            
                                                                                
            DP   := #( D[K] + A[K,K] - T*A[J,K] );                              
            D[K] := #*( DP );                                                   
            AK[K]:= #*( DP - D[K] );                                            
                                                                                
            AJ[K]:= RNULL;                                                        
            AK[J]:= RNULL;                                                        
                                                                                
            A[J]:= AJ; A[*,J]:= AJ;                                             
            A[K]:= AK; A[*,K]:= AK;                                             
                                                                                
            AJ:= RVECTOR(W[*,J]);                                               
            AK:= RVECTOR(W[*,K]);                                               
            IF TIEFE=0 THEN                                                     
            BEGIN                                                               
               W[*,J]:= C*AJ + S*AK;                                            
               W[*,K]:= C*AK - S*AJ;                                            
            END ELSE                                                            
            BEGIN                                                               
               AH:= AJ + S*( AK - TAU*AJ );                                     
               AK:= AK - S*( AJ + TAU*AK );                                     
               AJ:= AH;                                                         
               AJ[J]:= AJ[J] - S*TAU;                                           
               AJ[K]:= AJ[K] + S;                                               
               AK[J]:= AK[J] - S;                                               
               AK[K]:= AK[K] - S*TAU;                                           
               W[*,J]:= AJ;                                                     
               W[*,K]:= AK;                                                     
            END;                                                                
         END; { FOR K }                                                         
      END; { FOR J }                                                            
                                                                                
      ENDE:= TRUE;                                                              
      FOR J:= 1 TO N DO                                                         
      BEGIN                                                                     
        { IF TIEFE=0 THEN }  MIND:= ABS( D[J] )                                 
        {            ELSE  MIND:= ABS(A[J,J]) } ;                               
         MAX:= RNULL;                                                             
         FOR K:= 1 TO J-1 DO                                                    
         BEGIN                                                                  
            IF ABS(A[J,K])>MAX  THEN  MAX:= ABS(A[J,K]);                        
            IF ABS(A[K,J])>MAX  THEN  MAX:= ABS(A[K,J]);                        
         END;                                                                   
         ENDE:= ENDE AND ( MAX <= MIND*EPS );                                   
      END;                                                                      
   UNTIL ENDE;                                                                  
END;                                                                            
                                                                                
BEGIN { SEIG }                                                                  
   EPS1:= 1E-3;                                                                 
   EPS2:= 1E-5;                                                                 
   EPS3:= 1E-14;                                                                
   N   := UB(A0);                                                               
                                                                                
   EV := ID(N);                                                                 
   EV1:= RNULL;                                                                   
   D  := RNULL;                                                                   
   R  := RNULL;                                                                   
                                                                                
   A:= A0;                                                                      
                                                                                
   JACOBI( D, A, EV, 0, EPS1 );                                                 
{                                                                               
   bei geringen Genauigkeitsanspruechen kann hier mit                           
                                                                                
   EW:= D;                                                                      
                                                                                
   aufgehoert werden (evtl. noch EPS1 modifizieren ).                           
}                                                                               

   ORTHONORM( EV );                                                             
                                                                                
   A:= TRANSFORM( D, A0, EV );                                                  
                                                                                
   JACOBI( D, A, EV, 0, EPS2 );                                                 
{                                                                               
   bei mittleren Genauigkeitsanspruechen kann hier mit                          
                                                                                
   EW:= D;                                                                      
                                                                                
   aufgehoert werden (evtl. noch EPS1,EPS2 modifizieren ).                      
}                                                                               

   ORTHONORM( EV, R );                                                          
   A:= TRANSFORM( D, A0, EV, R );                                               
                                                                                
   JACOBI( D, A, EV1, 1, EPS3/N );                                              
                                                                                
   FOR J:= 1 TO N DO                                                            
   BEGIN                                                                        
      FOR I:= 1 TO N DO                                                         
      BEGIN                                                                     
         DP:= #( EV[I,J] + R[I,J] + RVECTOR(EV[I])*RVECTOR(EV1[*,J])            
                                  + RVECTOR( R[I])*RVECTOR(EV1[*,J]) );         
         HM[I,J]:= #*( DP );                                                    
         HV[I]  := #*( DP - HM[I,J] );                                          
      END;                                                                      
      EV1[*,J]:= HV;                                                            
   END;                                                                         
   EV:= HM;                                                                     
                                                                                
   EW:= D;                                                                      
                                                                                
{                                                                               
   ORTHONORM( EV, EV1 );                                                        
                                                                                
hier nur Berechnung von Einschliessungen:                                       
                                                                                
   NRM:= NORM( EV, EV1 );                                                       
   NRM:= NRM /> ( REINS -< NRM );                                                 
                                                                                
   FOR J:= 1 TO N DO                                                            
   BEGIN                                                                        
      AJ:= TRANSFORM( D, A0, EV, EV1, J, INTVAL(-NRM,NRM) );                    
                                                                                
      S:= RNULL;                                                                  
      FOR I:= 1 TO N DO   IF I<>J THEN S:= S +> SUP(ABS(AJ[I]));                
                                                                                
      EW[J]:= INTVAL( D[J] +< ( AJ[J].INF -< S ),                               
                      D[J] +> ( AJ[J].SUP +> S )  );                            
                                                                                
   END;                                                                         
                                                                                
   ERRCODE:= 0;                                                                 
}                                                                               
                                                                                
END  { SEIG_APP };
                                                                                
END.                                                                            
